const feature_type = {
    namespaced: true,
    state: {
        form: null,
        customForms: [],
        colorsStyleList: [],
        feature_types: [ // TODO: récupérer depuis le projet (à faire dans api)
            {
              geom_type: "point",
              title: "Éolienne",
              is_editable: true,
            },
            {
              geom_type: "linestring",
              title: "Limite illimitée",
              is_editable: true,
            },
            {
              geom_type: "polygon",
              title: "Zone de zonage",
              is_editable: true,
            }
          ],
    },
    mutations: {
        UPDATE_FORM(state, payload) {
            state.form = payload;
        },
        ADD_CUSTOM_FORM(state, dataKey) {
            state.customForms = [...state.customForms, { dataKey }];
        },
        UPDATE_CUSTOM_FORM(state, payload) {
            const index = state.customForms.findIndex((el) => el.dataKey === payload.dataKey);
            if (index !== -1) state.customForms[index] = payload
        },
        REMOVE_CUSTOM_FORM(state, payload) {
            state.customForms = state.customForms.filter(form => form.dataKey !== payload);
        },
        UPDATE_COLOR_STYLE(state) { // * un peu dirty (mais pas quick) car getter pas réactif avec nested et compliqué de faire dans composants enfants multiples
            let res = [];
            for (let form of state.customForms) {
                if (form.label) res.push(form);
            }
            state.colorsStyleList = res;
        }
    },
    getters: {

    },
    actions: {

        POST_FEATURE_TYPE({ state }) {
            const data = { form: state.form, formset: state.customForms }
            console.log("data", data)

            /* axios
              .post(`${DJANGO_API_BASE}feature_type/`, data)
              .then((response) => {
                const routerHistory = router.options.routerHistory 
                commit("SET_USER", response.data.user);
                router.push(routerHistory[routerHistory.length - 1] || "/")
                dispatch("GET_USER_LEVEL_PROJECTS");
              })
              .catch(() => {
                commit("SET_USER", false)
              }); */
        },
    },

}

export default feature_type